%% Sample mmaker input file.
%% Mark Allman (mallman@grc.nasa.gov)
%%
%% (any line starting with a '%' is just passed along to magicpoint
%% -- if it is not a command then it is a comment)
DEFINE: bgcolor white
%% DEFINE: bgrad 0 0 128 90 1 "black" "blue"
DEFINE: fgcolor black
DEFINE: bulcolor black
DEFINE: barcolor black
DEFINE: barwidth 5
%% DEFINE: lfooter Sept. 2002
%% DEFINE: rfooter Allman
%% DEFINE: cfooter Foo Conference
DEFINE: footcolor black

*Ac
*S 8
*Fbf



mmaker Example


*Fno
*S 6
Mark Allman
mallman@grc.nasa.gov
*S -
---
Setting Up

Lines at the beginning of the file that start with "DEFINE:" (case \
insensative) set various defaults for the set of slides (e.g., \
background color).  If you look in this file you'll see the \
defaults re-defined at the beginning of the time (except for the \
defines that are commented out -- which have no defaults and are \
presented as exmaples only).
---
A Slide

The title of the slide is given on the first line of the slide.

Everything after the first line is the body of the slides.

The first slide had a blank first line (after the comments and \
the defines) -- which means it had no title. 
---
+

If the title of a slide is a "+" the title of the last slide \
is used (with "(cont.)" tacked on the end).

As you can see, the "\" at the end of a line is used to continue \
a line, in the unix tradition of how things Should Work.

Also, you'll note that "---" on a line by itself separates one \
slide from the next.
---
Bullets

.Some number of spaces and then a "." at the beginning of a line \
 indicate a bullet item (zero is a number).
 .The number of spaces before the bullet defines the level of the \
  item.
  .See, this is the third level.

   .And, this is the fourth.
---
Commands

.mmaker treats lines beginning with a "*" as commands.
.The next few slides show some examples of these commands.
---
Alignment

You can format things, like so...


*Ac
This is centered.

*Ar
This is right justified.

*Al
Back to normal.
---
Fonts

.There are three out-of-the-box fonts (if you follow the directions \
 from the README):
 .Normal
*Fbf
 .A bold font.
*Ftt
 .A "typewriter" or courier font.
*Fit
 .An italics font
*Fno
 .Back to normal.

The fonts don't work right when generating postscript.  There are \
ways to fix this, but I haven't yet bothered to figure them out.
---
+

You can also change fonts in the middle of lines like *Fbf this!
*Fno

Or:

   For our simulations we used the *Ftt ns *Fno network simulator.
---
Font Sizes

.Also, you can change the size of the text...

*S 7
Size 7 type
*S 6 

Size 6 type
*S -

Normal size type (the "-" means return the the default on many of \
the mmaker commands).

The font size is preserved across slide boundaries.
---
Prefix

.You can use the "*PS x" command to set the default prefix for \
 each line to x spaces.

*PS 8
For instance, the text is now being indented by eight spaces.  \
And, this is a long line to show that when the text wraps around \
the new lines are indeed indented as appropriate.

*PS 4
Now things are indented 4 spaces.

*PS -
Now we're back to the default.
---
Numbered Lists

You can make mmaker number lists for you, like so:

# Item 1
# Item 2
 #10 And, you can make it start with a given number, like so.
 # Second level-2 bullet

When you start a new list you really should explicitly give the \
number of the first item, so...

#1 first
# second
 
is more appropriate.
---
LaTeX

You can inline LaTex, like so:
)$y = \frac{3}{4} \cdot x$
*Ilt 7

All consecutive lines that start with a ")" are handed to LaTeX \
together. 

Also note that the "*Ilt x" command is required after the \
embedded LaTeX stuff to actually suck the LaTeX image into the \
MGP file (The "*Ilt" command always sucks in the most recent latex \
produced bit).  The "x" is the percentage of screen the image will \
take up.  Or, more accurately the percentage of the space on the \
y-axis the image will take (the equation will be scaled \
appropriately along the x-axis).
---
Pausing

.You can make mgp print a slide in sections with pause commands \
 like so.
*P
.This bullet will show up after the "next" command (space, etc.) \
 is given by the user.
---
Spacing Between Lines

You can adjust the spacing between lines (the "vertical gap") using \
the "*V x" command -- where x is some integer (a percentage of the \
current font size, actually).  Some examples:

B
*V 10
B
*V 20
B
*V 50
B
*V 100
B
*V -
---
+

You can use the "*tight", "*Tight" and "*TIGHT" commands to crunch \
more things on each slide without fiddling with the "*V" command.  \
The next 4 slides are examples:
---
+

.1
.2
.3
.4
.5
.6
.7
.8
.9
.10
.11
.12
.13
.14
.15
.16
.17
.18
.19
.20
---
+

*tight
.1
.2
.3
.4
.5
.6
.7
.8
.9
.10
.11
.12
.13
.14
.15
.16
.17
.18
.19
.20
---
+

*Tight
.1
.2
.3
.4
.5
.6
.7
.8
.9
.10
.11
.12
.13
.14
.15
.16
.17
.18
.19
.20
---
+

*TIGHT
.1
.2
.3
.4
.5
.6
.7
.8
.9
.10
.11
.12
.13
.14
.15
.16
.17
.18
.19
.20
---
Images

To slurp in an image you can use the "*I f x" command -- where \
f is the name of the file and x is the percentage of the y-axis \
the image will occupy.

*Ac
*I tcp-bug.ps 60

This will suck in any sort of commands that magicpoint knows about.
---
+

Note: sucking in non-encapsulated postscript causes all sorts of \
headaches.  Either generate eps figures or get to know ps2eps.
---
Footers

We have a way to place footers on every slide.  For example:

*Bl left footer
*Bc center footer
*Br right footer
---
+

Footers can be overridden on subsequent slides, for instance:
*Br slide %d

Using a "%d" in any footer places the current slide number in \
the footer in place of the %d.

Also, note that there are 3 defines for setting footers at the \
beginning of your file.
---
Setting Parameters

All settings except the *S, *Bl, *Br and *Bc settings are reset \
at the beginning of each new slide.  
---
Connecting Slide Sets

Sometimes it is handy to collect input from a number of mmaker \
input files to present as one talk.  A few notes to help \
facilitate that:

The mmaker script leaves a ".mmaker-last-slide" file containing \
the number of the last slide processed when it is done.

When adding the second (third, etc.) mmaker input file to a \
talk use the "-a" option to append to the output file.  \
(This prevents a bunch of preamble stuff from being put 
into the middle of the generated .mgp file.)
---
+

You'll also want to start slide numbering at something besides \
1.  So, you'll need to use the "-n X" option which sets the first \
slide to number X+1.  A valid way to do this might be:

    mmaker -n `cat .mmaker-last-slide` -a input2 output
---
Other Options

Use "-p" to make output suitable for running through mgp2ps for \
making postscript slides.  This shouldn't be necessary, but there \
is a bug in the footer stuff that makes the PS output different \
than the screen output.  The "-p" hack fixes this (in a way that \
looks fine in the PS, but not on the screen).
---
MagicPoint Commands

You can freely use raw magicpoint commands in your input.  A \
line that begins with a "%" is simply passed 
to mgp.
---
Makefile

In the Example/ directory there is a Makefile that should be \
pretty generic.  If you tweak the location of mmaker and the name \
of the input file you should be able to use it for your own slides \
pretty easily.
---
Summary

I hope this pre-processor helps you out.  If you have problems \
or add something cool let me know.

I could hope to have better documentation in the future...
